require('json')
require('socket.http')
require("ltn12")

socket.http.TIMEOUT = 10
 
--**********************************************************
-->>>>>>>>>>>>>USER MODIFICATION AREA (BEGIN)<<<<<<<<<<<<<<<
--**********************************************************

local searchBy = 0								-- 0-search by city name; 1-search by cityID
local city = 'Prague,CZ'					--city name
local cityID= '3067696'									--city ID (see openweathermap.org)
local units = 'metric'						--units of measured values: metric/imperial
local lang = 'en'									--[[language of weather description
																		English - en, Russian - ru, Italian - it, Spanish - es (or sp),
																		Ukrainian - uk (or ua), German - de, Portuguese - pt, Romanian - ro,
																		Polish - pl, Finnish - fi, Dutch - nl, French - fr, Bulgarian - bg,
																		Swedish - sv (or se), Chinese Traditional - zh_tw,
																		Chinese Simplified - zh (or zh_cn), Turkish - tr, Croatian - hr, Catalan - ca --]] 
local proxy='http://10.154.24.21:8080/'	--set proxy server e.g. 'http://10.10.10.10/'. If no proxy is needed set proxy=nil

local apikey='d3e7869ddf2ad1c8b7c3e7120e8597a8'	--API key can be retrieved after registration on http://openweathermap.org/appid
--**********************************************************
-->>>>>>>>>>>>>USER MODIFICATION AREA (END)<<<<<<<<<<<<<<<<<
--**********************************************************

local data,_, code, headers, status, ret
local proxyServer="http://10.154.24.21:8080/"

local response = {}

if searchBy==0 then
		_, code, headers, status = socket.http.request{
    url='http://api.openweathermap.org/data/2.5/forecast/daily?q='..city..'&mode=json&units='..units..'&lang='..lang..'&cnt=4'..'&APPID='..apikey, 
  		  sink = ltn12.sink.table(response),
    		proxy=proxy
  	}
elseif searchBy== 1 then
  		_, code, headers, status = socket.http.request{
    		url='http://api.openweathermap.org/data/2.5/forecast/daily?q='..city..'&mode=json&units='..units..'&lang='..lang..'&cnt=4'..'&APPID='..apikey, 
  		  sink = ltn12.sink.table(response),
    		proxy=proxy
  	}
end

if code==200 then 
  alert('Fetch OK')
else
  alert('Weather: cannot fetch data. Status code: '..code)
  return
end

ret = table.concat(response)
data = json.pdecode(ret)
if not data then
  alert('Weather: cannot parse data')
  return
end

grp.update('5/1/1', (data.list[1].temp.day),dt.float16) 		--Day temperature [Celsius deg]
grp.update('5/1/2', (data.list[1].temp.min),dt.float16) 		--Min daily temperature
grp.update('5/1/3', (data.list[1].temp.max),dt.float16) 		--Max daily temperature
grp.update('5/1/4', (data.list[1].temp.night),dt.float16) 	--Night temperature
grp.update('5/1/5', (data.list[1].temp.eve),dt.float16)		--Evening temperature
grp.update('5/1/6', (data.list[1].temp.morn),dt.float16)		--Morning temperature
grp.update('5/1/7', (data.list[1].pressure),dt.float16)		--Atmosperic pressure (on the sea level) [hPa]
grp.update('5/1/8', (data.list[1].humidity),dt.float16)		--Humidity [%]
grp.update('5/1/9',	(data.list[1].speed),dt.float16)			--Wind speed [mps]
grp.update('5/1/10', (data.list[1].deg),dt.angle)					--Wind direction [degress], meteorological
grp.update('5/1/11', (data.list[1].clouds),dt.scale)				--Cloudiness [%]
grp.update('5/1/12', (data.list[1].weather[1].id),dt.int16)--Weather condition ID
grp.update('5/1/13', (data.list[1].weather[1].main),dt.string)--Group of weather parameters (Rain, Snow, Extreme)
grp.update('5/1/14', (data.list[1].weather[1].description),dt.string)--Weather condition within the group
grp.update('5/1/15', (data.list[1].weather[1].icon),dt.string)--Weather icon ID
grp.update('5/1/16', (data.list[1].rain),dt.float16)				--Precipitation volume for last 3 hours, [mm]
grp.update('5/1/17', (data.list[1].snow),dt.float16)				--Snow volume, [mm]


grp.update('5/2/1', (data.list[2].temp.day),dt.float16) 		--Day temperature [Celsius deg]
grp.update('5/2/2', (data.list[2].temp.min),dt.float16) 		--Min daily temperature
grp.update('5/2/3', (data.list[2].temp.max),dt.float16) 		--Max daily temperature
grp.update('5/2/4', (data.list[2].temp.night),dt.float16) 	--Night temperature
grp.update('5/2/5', (data.list[2].temp.eve),dt.float16)		--Evening temperature
grp.update('5/2/6', (data.list[2].temp.morn),dt.float16)		--Morning temperature
grp.update('5/2/7', (data.list[2].pressure),dt.float16)		--Atmosperic pressure (on the sea level) [hPa]
grp.update('5/2/8', (data.list[2].humidity),dt.float16)		--Humidity [%]
grp.update('5/2/9',	(data.list[2].speed),dt.float16)			--Wind speed [mps]
grp.update('5/2/10', (data.list[2].deg),dt.angle)					--Wind direction [degress], meteorological
grp.update('5/2/11', (data.list[2].clouds),dt.scale)				--Cloudiness [%]
grp.update('5/2/12', (data.list[2].weather[1].id),dt.int16)--Weather condition ID
grp.update('5/2/13', (data.list[2].weather[1].main),dt.string)--Group of weather parameters (Rain, Snow, Extreme)
grp.update('5/2/14', (data.list[2].weather[1].description),dt.string)--Weather condition within the group
grp.update('5/2/15', (data.list[2].weather[1].icon),dt.string)--Weather icon ID
grp.update('5/2/16', (data.list[2].rain),dt.float16)				--Precipitation volume for last 3 hours, [mm]
grp.update('5/2/17', (data.list[2].snow),dt.float16)				--Snow volume, [mm]


grp.update('5/3/1', (data.list[3].temp.day),dt.float16) 		--Day temperature [Celsius deg]
grp.update('5/3/2', (data.list[3].temp.min),dt.float16) 		--Min daily temperature
grp.update('5/3/3', (data.list[3].temp.max),dt.float16) 		--Max daily temperature
grp.update('5/3/4', (data.list[3].temp.night),dt.float16) 	--Night temperature
grp.update('5/3/5', (data.list[3].temp.eve),dt.float16)		--Evening temperature
grp.update('5/3/6', (data.list[3].temp.morn),dt.float16)		--Morning temperature
grp.update('5/3/7', (data.list[3].pressure),dt.float16)		--Atmosperic pressure (on the sea level) [hPa]
grp.update('5/3/8', (data.list[3].humidity),dt.float16)		--Humidity [%]
grp.update('5/3/9',	(data.list[3].speed),dt.float16)			--Wind speed [mps]
grp.update('5/3/10', (data.list[3].deg),dt.angle)					--Wind direction [degress], meteorological
grp.update('5/3/11', (data.list[3].clouds),dt.scale)				--Cloudiness [%]
grp.update('5/3/12', (data.list[3].weather[1].id),dt.int16)--Weather condition ID
grp.update('5/3/13', (data.list[3].weather[1].main),dt.string)--Group of weather parameters (Rain, Snow, Extreme)
grp.update('5/3/14', (data.list[3].weather[1].description),dt.string)--Weather condition within the group
grp.update('5/3/15', (data.list[3].weather[1].icon),dt.string)--Weather icon ID
grp.update('5/3/16', (data.list[3].rain),dt.float16)				--Precipitation volume for last 3 hours, [mm]
grp.update('5/3/17', (data.list[3].snow),dt.float16)				--Snow volume, [mm]


grp.update('5/4/1', (data.list[4].temp.day),dt.float16) 		--Day temperature [Celsius deg]
grp.update('5/4/2', (data.list[4].temp.min),dt.float16) 		--Min daily temperature
grp.update('5/4/3', (data.list[4].temp.max),dt.float16) 		--Max daily temperature
grp.update('5/4/4', (data.list[4].temp.night),dt.float16) 	--Night temperature
grp.update('5/4/5', (data.list[4].temp.eve),dt.float16)		--Evening temperature
grp.update('5/4/6', (data.list[4].temp.morn),dt.float16)		--Morning temperature
grp.update('5/4/7', (data.list[4].pressure),dt.float16)		--Atmosperic pressure (on the sea level) [hPa]
grp.update('5/4/8', (data.list[4].humidity),dt.float16)		--Humidity [%]
grp.update('5/4/9',	(data.list[4].speed),dt.float16)			--Wind speed [mps]
grp.update('5/4/10', (data.list[4].deg),dt.angle)					--Wind direction [degress], meteorological
grp.update('5/4/11', (data.list[4].clouds),dt.scale)				--Cloudiness [%]
grp.update('5/4/12', (data.list[4].weather[1].id),dt.int16)--Weather condition ID
grp.update('5/4/13', (data.list[4].weather[1].main),dt.string)--Group of weather parameters (Rain, Snow, Extreme)
grp.update('5/4/14', (data.list[4].weather[1].description),dt.string)--Weather condition within the group
grp.update('5/4/15', (data.list[4].weather[1].icon),dt.string)--Weather icon ID
grp.update('5/4/16', (data.list[4].rain),dt.float16)				--Precipitation volume for last 3 hours, [mm]
grp.update('5/4/17', (data.list[4].snow),dt.float16)				--Snow volume, [mm]


log("Fetch of forecasted weather data done.")
